/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: c_bitvector.c,v 1.1 2002/08/16 12:17:36 malekith Exp $
 *
 * Standard library for Gont, Bitvector module C implementation.
 *
 * TODO: reimplement this, it's horrible.
 */

#include <gont/runtime.h>
#include <gont/array.h>

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef struct gont_array *t;

t gont_make_array(gont_ptroff sz);

t Bitvector__make(gont_ptroff sz, gont_ptroff ini)
{
	t ret = gont_make_array(sz);

	if (ini != 0) {
		gont_ptroff i;

		for (i = 0; i < sz; i++)
			ret->data[i] = ini;
	}

	return ret;
}

t Bitvector__copy(t src)
{
	t ret = gont_make_array(src->size);

	memcpy(ret->data, src->data, src->size * sizeof(gont_ptroff));

	return ret;
}

t Bitvector__init(gont_ptroff sz, struct gont_lambda_exp *ini)
{
	t ret = gont_make_array(sz);
	gont_ptroff i;

	for (i = 0; i < sz; i++) {
		ret->data[i] = (gont_ptroff)ini->fnc(ini->closure, i);
	}

	return ret;
}

gont_ptroff Bitvector__length(t ar)
{
	return ar->size;
}

void Bitvector__set(t ar, gont_ptroff idx, gont_ptroff val)
{
	if (idx >= ar->size)
		gont_invalid_argument("Bitvector::set");
		
	ar->data[idx] = val;
}

gont_ptroff Bitvector__get(t ar, gont_ptroff idx)
{
	if (idx >= ar->size)
		gont_invalid_argument("Bitvector::get");
		
	return ar->data[idx];
}

/* TODO: calling this with newsz++ gets O(n^2) complexity, while we
 * can get O(nlogn). */
void Bitvector__resize(t ar, gont_ptroff newsz, gont_ptroff ini)
{
	gont_ptroff *newdata = gont_xmalloc(newsz * sizeof(gont_ptroff));

	if (newsz > ar->size) {
		gont_ptroff i;
		
		memcpy(newdata, ar->data, ar->size * sizeof(gont_ptroff));
		
		for (i = ar->size; i < newsz; i++)
			newdata[i] = ini;
	} else {
		memcpy(newdata, ar->data, newsz * sizeof(gont_ptroff));
	}

	ar->size = newsz;
	ar->data = newdata;
}
