/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: c_sys.c,v 1.2 2002/08/16 12:17:36 malekith Exp $
 *
 * Standard library for Gont, Sys module C implementation.
 */

#include <gont/runtime.h>

int Sys___get_argc(void)
{
	return gont_argc;
}

struct gont_string *Sys___get_argv(gont_ptroff idx)
{
	return gont_cstring(gont_argv[idx]);
}

#include <sys/times.h>
#include <unistd.h>
#include <errno.h>

void **Sys__times(void)
{
	struct tms t;
	if (times(&t) == (clock_t) -1)
		gont_sys_error(errno);
	return gont_make_tuple(2, (void*) t.tms_utime, (void*)t.tms_stime);
}

gont_ptroff Sys__clk_tck(void)
{
	return sysconf(_SC_CLK_TCK);
}
