/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: bind.gi,v 1.1 2002/08/14 11:59:22 malekith Exp $
 *
 * Bind - Name binder. 
 */
 
open Ast;

/* Bind symbols, i.e. replace SimpleName and QualifiedName in <'a>bindable
 * with Symbol. This is two phase process, first all symbols are entered
 * into global namespace, and then symbols are bound. 
 *
 * Second phase also ensures all named types have right number of type
 * parameters.
 */

// This has to be called first, once per compiled module.
void init(id mod_name, bool iface);

void enter_decl(decl d); 
void bind_decl(decl d); 

// Save compiled module interface to given filename.
void save_module(string filename);

<id>List::t used_modules();
<id>List::t referenced_modules();
<id>List::t used_exns();

// For Cast
<id>List::t simple_fv(ty t);

// for Xmldump etc
string current_module;
bool doing_iface;

// uh, no protos, don't look here :<
type CTX
void bind_stmt(CTX c, stmt s);
void bind_pattern(CTX c, pattern p);
void bind_expr(CTX c, expr e);
