/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: ptrhash.gi,v 1.1 2002/08/16 12:17:36 malekith Exp $
 *
 * Standard library for Gont, Ptrhash module interface.
 *
 * Hash from whatever to whatever. However first whatever is treated as
 * pointer (no structural equality).
 */

// hash from 'a to 'b
type <'a, 'b>t;

<'a, 'b>t create(int size_hint);

// can raise Not_found
'b find(<'a, 'b>t, 'a);
void remove(<'a, 'b>t h, 'a k);
// this cannot
<'b>List::t find_all(<'a, 'b>t, 'a);
void remove_all(<'a, 'b>t h, 'a k);
bool mem(<'a, 'b>t, 'a);
void add(<'a, 'b>t, 'a, 'b);
<'a, 'b>t copy(<'a, 'b>t h);
int length(<'a, 'b>t h);

// WARNING: this traverses hash in *random* order, i.e. the order depends
// on random things, like where malloc() is going to give you memory
void iter(<'a, 'b>t h, *(void ('a, 'b)) f);
